2 # Copyright (c) 2007, Nanako Shiraishi
4 dashless
=$
(basename "$0" |
sed -e 's/-/ /')
5 USAGE
="list [<options>]
6 or: $dashless show [<stash>]
7 or: $dashless drop [-q|--quiet] [<stash>]
8 or: $dashless ( pop | apply ) [--index] [-q|--quiet] [<stash>]
9 or: $dashless branch <branchname> [<stash>]
10 or: $dashless save [--patch] [-k|--[no-]keep-index] [-q|--quiet]
11 [-u|--include-untracked] [-a|--all] [<message>]
12 or: $dashless [push [--patch] [-k|--[no-]keep-index] [-q|--quiet]
13 [-u|--include-untracked] [-a|--all] [-m <message>]
22 prefix
=$
(git rev-parse
--show-prefix) ||
exit 1
25 TMP
="$GIT_DIR/.git-stash.$$"
26 TMPindex
=${GIT_INDEX_FILE-"$(git rev-parse --git-path index)"}.stash.$$
27 trap 'rm -f "$TMP-"* "$TMPindex"' 0
31 if git config
--get-colorbool color.interactive
; then
32 help_color
="$(git config --get-color color.interactive.help 'red bold')"
33 reset_color
="$(git config --get-color '' reset)"
40 git diff-index
--quiet --cached HEAD
--ignore-submodules -- "$@" &&
41 git diff-files
--quiet --ignore-submodules -- "$@" &&
42 (test -z "$untracked" ||
test -z "$(untracked_files)")
46 excl_opt
=--exclude-standard
47 test "$untracked" = "all" && excl_opt
=
48 git ls-files
-o -z $excl_opt -- "$@"
54 die
"$(gettext "git stash
clear with parameters is unimplemented
")"
56 if current
=$
(git rev-parse
--verify --quiet $ref_stash)
58 git update-ref
-d $ref_stash $current
70 stash_msg
=${1?"BUG: create_stash () -m requires an argument"}
72 -u|
--include-untracked)
74 untracked
=${1?"BUG: create_stash () -u requires an argument"}
84 git update-index
-q --refresh
90 # state of the base commit
91 if b_commit
=$
(git rev-parse
--verify HEAD
)
93 head=$
(git rev-list
--oneline -n 1 HEAD
--)
95 die
"$(gettext "You
do not have the initial commit yet
")"
98 if branch
=$
(git symbolic-ref
-q HEAD
)
100 branch
=${branch#refs/heads/}
104 msg
=$
(printf '%s: %s' "$branch" "$head")
107 i_tree
=$
(git write-tree
) &&
108 i_commit
=$
(printf 'index on %s\n' "$msg" |
109 git commit-tree
$i_tree -p $b_commit) ||
110 die
"$(gettext "Cannot save the current index state
")"
112 if test -n "$untracked"
114 # Untracked files are stored by themselves in a parentless commit, for
115 # ease of unpacking later.
117 untracked_files
"$@" |
(
118 GIT_INDEX_FILE
="$TMPindex" &&
119 export GIT_INDEX_FILE
&&
121 git update-index
-z --add --remove --stdin &&
122 u_tree
=$
(git write-tree
) &&
123 printf 'untracked files on %s\n' "$msg" | git commit-tree
$u_tree &&
125 ) ) || die
"$(gettext "Cannot save the untracked files
")"
127 untracked_commit_option
="-p $u_commit";
129 untracked_commit_option
=
132 if test -z "$patch_mode"
135 # state of the working tree
137 git read-tree
--index-output="$TMPindex" -m $i_tree &&
138 GIT_INDEX_FILE
="$TMPindex" &&
139 export GIT_INDEX_FILE
&&
140 git diff-index
--name-only -z HEAD
-- "$@" >"$TMP-stagenames" &&
141 git update-index
-z --add --remove --stdin <"$TMP-stagenames" &&
145 die
"$(gettext "Cannot save the current worktree state
")"
149 rm -f "$TMP-index" &&
150 GIT_INDEX_FILE
="$TMP-index" git read-tree HEAD
&&
152 # find out what the user wants
153 GIT_INDEX_FILE
="$TMP-index" \
154 git add--interactive
--patch=stash
-- "$@" &&
156 # state of the working tree
157 w_tree
=$
(GIT_INDEX_FILE
="$TMP-index" git write-tree
) ||
158 die
"$(gettext "Cannot save the current worktree state
")"
160 git diff-tree
-p HEAD
$w_tree -- >"$TMP-patch" &&
161 test -s "$TMP-patch" ||
162 die
"$(gettext "No changes selected
")"
164 rm -f "$TMP-index" ||
165 die
"$(gettext "Cannot remove temporary index
(can
't happen)")"
170 if test -z "$stash_msg"
172 stash_msg=$(printf 'WIP on
%s
' "$msg")
174 stash_msg=$(printf 'On
%s
: %s
' "$branch" "$stash_msg")
176 w_commit=$(printf '%s
\n' "$stash_msg" |
177 git commit-tree $w_tree -p $b_commit -p $i_commit $untracked_commit_option) ||
178 die "$(gettext "Cannot record working tree state")"
199 die "$(eval_gettext "\"$dashless store\" requires one <commit> argument")"
202 if test -z "$stash_msg"
204 stash_msg="Created via \"git stash store\"."
207 git update-ref --create-reflog -m "$stash_msg" $ref_stash $w_commit
209 test $ret != 0 && test -z "$quiet" &&
210 die "$(eval_gettext "Cannot update \$ref_stash with \$w_commit")"
230 # only default to keep if we don't already have an override
231 test -z "$keep_index" && keep_index
=t
236 -u|
--include-untracked)
244 test -z ${1+x} && usage
256 # TRANSLATORS: $option is an invalid option, like
257 # `--blah-blah'. The 7 spaces at the beginning of the
258 # second line correspond to "error: ". So you should line
259 # up the second line with however many characters the
260 # translation of "error: " takes in your language. E.g. in
263 # $ git stash save --blah-blah 2>&1 | head -n 2
264 # error: unknown option for 'stash save': --blah-blah
265 # To provide a message, use git stash save -- '--blah-blah'
266 eval_gettextln
"error: unknown option for 'stash save': \$option
267 To provide a message, use git stash save -- '\$option'"
277 eval "set $(git rev-parse --sq --prefix "$prefix" -- "$@
")"
279 if test -n "$patch_mode" && test -n "$untracked"
281 die
"$(gettext "Can
't use --patch and --include-untracked or --all at the same time")"
284 test -n "$untracked" || git ls-files --error-unmatch -- "$@" >/dev/null || exit 1
286 git update-index -q --refresh
289 say "$(gettext "No local changes to save")"
293 git reflog exists $ref_stash ||
294 clear_stash || die "$(gettext "Cannot initialize stash")"
296 create_stash -m "$stash_msg" -u "$untracked" -- "$@"
297 store_stash -m "$stash_msg" -q $w_commit ||
298 die "$(gettext "Cannot save the current status")"
299 say "$(eval_gettext "Saved working directory and index state \$stash_msg")"
301 if test -z "$patch_mode"
306 git ls-files -z --modified -- "$@" |
307 git checkout-index -z --force --stdin
308 git clean --force -q -d -- "$@"
312 test "$untracked" = "all" && CLEAN_X_OPTION=-x || CLEAN_X_OPTION=
313 if test -n "$untracked"
315 git clean --force --quiet -d $CLEAN_X_OPTION -- "$@"
318 if test "$keep_index" = "t" && test -n "$i_tree"
320 git read-tree --reset $i_tree
321 git ls-files -z --modified -- "$@" |
322 git checkout-index -z --force --stdin
325 git apply -R < "$TMP-patch" ||
326 die "$(gettext "Cannot remove worktree changes")"
328 if test "$keep_index" != "t"
345 # pass all options through to push_stash
346 push_options="$push_options $1"
357 if test -z "$stash_msg"
359 push_stash $push_options
361 push_stash $push_options -m "$stash_msg"
366 git rev-parse --verify --quiet $ref_stash >/dev/null
370 have_stash || return 0
371 git log --format="%gd: %gs" -g --first-parent -m "$@" $ref_stash --
375 ALLOW_UNKNOWN_FLAGS=t
376 assert_stash_like "$@"
380 if test "$(git config --bool stash.showStat || echo true)" = "true"
385 if test "$(git config --bool stash.showPatch || echo false)" = "true"
387 FLAGS=${FLAGS}${FLAGS:+ }-p
396 git diff ${FLAGS} $b_commit $w_commit
405 # Parses the remaining options looking for flags and
406 # at most one revision defaulting to ${ref_stash}@{0}
409 # Derives related tree and commit objects from the
410 # revision, if one is found.
412 # stash records the work tree, and is a merge between the
413 # base commit (first parent) and the index tree (second parent).
415 # REV is set to the symbolic version of the specified stash-like commit
416 # IS_STASH_LIKE is non-blank if ${REV} looks like a stash
417 # IS_STASH_REF is non-blank if the ${REV} looks like a stash ref
418 # s is set to the SHA1 of the stash commit
419 # w_commit is set to the commit containing the working tree
420 # b_commit is set to the base commit
421 # i_commit is set to the commit containing the index tree
422 # u_commit is set to the commit containing the untracked files tree
423 # w_tree is set to the working tree
424 # b_tree is set to the base tree
425 # i_tree is set to the index tree
426 # u_tree is set to the untracked files tree
428 # GIT_QUIET is set to t if -q is specified
429 # INDEX_OPTION is set to --index if --index is specified.
430 # FLAGS is set to the remaining flags (if allowed)
433 # * too many revisions specified
434 # * no revision is specified and there is no stash stack
435 # * a revision is specified which cannot be resolve to a SHA1
436 # * a non-existent stash reference is specified
437 # * unknown flags were set and ALLOW_UNKNOWN_FLAGS is not "t"
440 parse_flags_and_rev()
442 test "$PARSE_CACHE" = "$*" && return 0 # optimisation
473 test "$ALLOW_UNKNOWN_FLAGS" = t ||
474 die "$(eval_gettext "unknown option: \$opt")"
475 FLAGS="${FLAGS}${FLAGS:+ }$opt"
478 REV="${REV}${REV:+ }'$opt'"
487 have_stash || die "$(gettext "No stash found.")"
488 set -- ${ref_stash}@{0}
494 die "$(eval_gettext "Too many revisions specified: \$REV")"
503 set -- "${ref_stash}@{$1}"
507 REV=$(git rev-parse --symbolic --verify --quiet "$1") || {
509 die "$(eval_gettext "\$reference is not a valid reference")"
512 i_commit=$(git rev-parse --verify --quiet "$REV^2") &&
513 set -- $(git rev-parse "$REV" "$REV^1" "$REV:" "$REV^1:" "$REV^2:" 2>/dev/null) &&
521 test "$ref_stash" = "$(git rev-parse --symbolic-full-name "${REV%@*}")" &&
524 u_commit=$(git rev-parse --verify --quiet "$REV^3") &&
525 u_tree=$(git rev-parse "$REV^3:" 2>/dev/null)
530 parse_flags_and_rev "$@"
531 test -n "$IS_STASH_LIKE"
534 assert_stash_like() {
535 is_stash_like "$@" || {
537 die "$(eval_gettext "'\
$args' is not a stash-like commit")"
542 is_stash_like "$@" && test -n "$IS_STASH_REF"
546 is_stash_ref "$@" || {
548 die "$(eval_gettext "'\
$args' is not a stash reference")"
554 assert_stash_like "$@"
556 git update-index -q --refresh || die "$(gettext "unable to refresh index")"
558 # current index state
559 c_tree=$(git write-tree) ||
560 die "$(gettext "Cannot apply a stash in the middle of a merge")"
562 unstashed_index_tree=
563 if test -n "$INDEX_OPTION" && test "$b_tree" != "$i_tree" &&
564 test "$c_tree" != "$i_tree"
566 git diff-tree --binary $s^2^..$s^2 | git apply --cached
568 die "$(gettext "Conflicts in index. Try without --index.")"
569 unstashed_index_tree=$(git write-tree) ||
570 die "$(gettext "Could not save index tree")"
576 GIT_INDEX_FILE="$TMPindex" git-read-tree "$u_tree" &&
577 GIT_INDEX_FILE="$TMPindex" git checkout-index --all &&
579 die "$(gettext "Could not restore untracked files from stash")"
583 GITHEAD_$w_tree='Stashed changes
' &&
584 GITHEAD_$c_tree='Updated upstream
' &&
585 GITHEAD_$b_tree='Version stash was based on
' &&
586 export GITHEAD_$w_tree GITHEAD_$c_tree GITHEAD_$b_tree
589 if test -n "$GIT_QUIET"
591 GIT_MERGE_VERBOSITY=0 && export GIT_MERGE_VERBOSITY
593 if git merge-recursive $b_tree -- $c_tree $w_tree
596 if test -n "$unstashed_index_tree"
598 git read-tree "$unstashed_index_tree"
601 git diff-index --cached --name-only --diff-filter=A $c_tree >"$a" &&
602 git read-tree --reset $c_tree &&
603 git update-index --add --stdin <"$a" ||
604 die "$(gettext "Cannot unstage modified files")"
608 if test -n "$GIT_QUIET"
610 squelch='>/dev
/null
2>&1'
612 (cd "$START_DIR" && eval "git status $squelch") || :
614 # Merge conflict; keep the exit status from merge-recursive
617 if test -n "$INDEX_OPTION"
619 gettextln "Index was not unstashed." >&2
626 assert_stash_ref "$@"
633 say "$(gettext "The stash is kept in case you need it again.")"
639 assert_stash_ref "$@"
641 git reflog delete --updateref --rewrite "${REV}" &&
642 say "$(eval_gettext "Dropped \${REV} (\$s)")" ||
643 die "$(eval_gettext "\${REV}: Could not drop stash entry")"
645 # clear_stash if we just dropped the last stash entry
646 git rev-parse --verify --quiet "$ref_stash@{0}" >/dev/null ||
651 test -n "$1" || die "$(gettext "No branch name specified")"
656 assert_stash_like "$@"
658 git checkout -b $branch $REV^ &&
659 apply_stash "$@" && {
660 test -z "$IS_STASH_REF" || drop_stash "$@"
664 test "$1" = "-p" && set "push" "$@"
666 PARSE_CACHE='--not-parsed'
667 # The default command is "push" if nothing but options are given
674 *) seen_non_option=t; break ;;
678 test -n "$seen_non_option" || set "push" "$@"
708 create_stash -m "$*" && echo "$w_commit"
730 say "$(gettext "(To restore them type \"git stash apply\")")"